<script setup lang="ts">
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";

const workspaceStore = useWorkspaceStore();
const { data: session } = useAuth();
const showDialog = ref(false);
const title = ref("My account");

const menu = computed(() => {
  const menu = [
    {
      title: "My account",
      icon: "mdi-account-circle-outline",
    },
    {
      title: "My parameters",
      icon: "mdi-tune-variant",
    },
    {
      title: "Tokens",
      icon: "mdi-key-outline",
    },
  ];
  if (workspaceStore.workspacesCount > 0) {
    menu.push({
      title: "Workspace",
      items: [
        {
          title: "Settings",
          icon: "mdi-cog-outline",
        },
        {
          title: "Members",
          icon: "mdi-account-multiple-outline",
        },
        {
          title: "Connections",
          icon: "mdi-transit-connection-variant",
        },
      ],
    });
  }
  return menu;
});

function onDialogClosed(isOpen) {
  if (!isOpen) {
    title.value = "My account";
  }
}
</script>

<template>
  <v-list-item
    density="compact"
    class="ma-0 pa-0"
    :active="showDialog"
    @click="showDialog = true"
  >
    <v-icon class="me-2">
      mdi-cog-outline
    </v-icon> {{ $t("parameters") }}
  </v-list-item>

  <v-dialog
    v-model="showDialog"
    width="100%"
    height="100%"
    style="max-width: 1150px !important; max-height: 850px"
    @update:showDialog="showDialog = $event"
    @update:modelValue="onDialogClosed"
  >
    <v-card class="ma-0 pa-0 fill-height">
      <v-card-text class="ma-0 pa-0 fill-height">
        <v-row class="fill-height ma-0">
          <v-col style="max-width: 240px !important; height: 100%" class="bgGray">
            <v-sheet class="d-flex align-center pa-1 bgGray">
              <img
                :src="getGravatar(session?.user?.email, 24)"
                alt=""
                style="border-radius: 50%; margin: 0; padding: 0"
                class="me-3"
              >
              <div
                id="username"
                style="overflow: hidden; white-space: nowrap; text-overflow: ellipsis; width: 210px"
              >
                <span class="text-subtitle-2 font-weight-bold">{{ session?.user?.name }}</span>
                <br>
                <span class="text-caption">{{ session?.user?.email }}</span>
              </div>
            </v-sheet>
            <v-list class="bgGray">
              <template v-for="(m, index) in menu">
                <v-list-item v-if="m.items" :key="`parent-${index}`">
                  <v-list-item-title class="d-flex align-center">
                    <p v-if="m.title === 'Workspace'" class="font-weight-bold">
                      {{ $t("workspace") }}
                    </p>
                  </v-list-item-title>
                </v-list-item>
                <v-list-item
                  v-else
                  :key="`item-${index}`"
                  :value="m.title"
                  :active="title === m.title"
                  :class="{ 'primary--text': title === m.title }"
                  @click="title = m.title"
                >
                  <v-list-item-title class="d-flex align-center">
                    <v-icon class="me-3">
                      {{ m.icon }}
                    </v-icon>
                    <p v-if="m.title === 'My account'">
                      {{ $t("my_account") }}
                    </p>
                    <p v-if="m.title === 'My parameters'">
                      {{ $t("my_parameters") }}
                    </p>
                    <p v-if="m.title === 'Tokens'">
                      {{ $t("tokens") }}
                    </p>
                  </v-list-item-title>
                </v-list-item>
                <!-- items in sub menu -->
                <template v-if="m.items">
                  <v-list-item
                    v-for="(item, i) in m.items"
                    :key="`submenu-${i}`"
                    :value="item.title"
                    :class="{ 'primary--text': title === item.title }"
                    @click="title = item.title"
                  >
                    <v-list-item-title class="d-flex align-center">
                      <v-icon class="me-3">
                        {{ item.icon }}
                      </v-icon>
                      <p v-if="item.title === 'Settings'">
                        {{ $t("settings") }}
                      </p>
                      <p v-if="item.title === 'Members'">
                        {{ $t("members") }}
                      </p>
                      <p v-if="item.title === 'Connections'">
                        {{ $t("connections") }}
                      </p>
                    </v-list-item-title>
                  </v-list-item>
                </template>
              </template>
            </v-list>
          </v-col>
          <v-col style="width: calc(100%-240px); height: 100%; overflow: auto">
            <UserAccount v-if="title === 'My account'" />
            <UserParameters v-else-if="title === 'My parameters'" />
            <UserToken v-else-if="title === 'Tokens'" />
            <WorkspaceSettings v-else-if="title === 'Settings'" @showDialog="showDialog = $event" />
            <WorkspaceMembers v-else-if="title === 'Members'" @showDialog="showDialog = $event" />
            <WorkspaceConnections v-else-if="title === 'Connections'" />
          </v-col>
        </v-row>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<style>
.bgGray {
  background: rgb(var(--v-theme-background-gray));
}
</style>
